
function mockmethod(spec, name, ctx) {
	const method = spec.methods[name];
	if (!method) {
		throw new Error(`failed to find method: ${name}`);
	}

	const req = { params: {} };
	Object.keys(method.parameter.properties).forEach((param) => {
		req.params[param] = ctx[param];
	});

	return new Promise((resolve) => {
		const cb = (...args) => {
			resolve(args);
		};

		Object.keys(method.outputs).forEach((output) => {
			cb[output] = (...args) => {
				resolve({
					[output]: args
				});
			};
		});
		method.action(req, cb);
	});
}

function mocknode(specs, name) {
	const spec = specs[name];
	if (!spec) {
		throw new Error(`failed to find spec for: ${name}`);
	}
	return {
		invoke: mockmethod.bind(null, spec)
	};
}

function mockspecs(node) {
	return {
		node: mocknode.bind(null, node.specs)
	};
}

exports = module.exports = mockspecs;
